## kodi-addon-imagedecoder-raw-20.1.0-16.src.tar.gz

=== depends/common/lcms2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(lcms2)

include(ExternalProject)

externalproject_add(libraw
  SOURCE_DIR ${CMAKE_SOURCE_DIR}
  CONFIGURE_COMMAND CC=${CMAKE_C_COMPILER} AR=${CMAKE_AR}
                    ${CMAKE_SOURCE_DIR}/configure
                      --enable-static
                      --disable-shared
                      --enable-jpeg
                      --with-pic
                      --prefix=${OUTPUT_DIR}
  INSTALL_COMMAND ""
  BUILD_IN_SOURCE 1)

install(CODE "execute_process(COMMAND make install WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})")

=== depends/common/libraw/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(libraw)

include(ExternalProject)

externalproject_add(libraw
  SOURCE_DIR ${CMAKE_SOURCE_DIR}
  UPDATE_COMMAND autoreconf -vif
  CONFIGURE_COMMAND CC=${CMAKE_C_COMPILER} AR=${CMAKE_AR}
                    ${CMAKE_SOURCE_DIR}/configure
                      --disable-examples
                      --disable-shared
                      --disable-jasper
                      --disable-openmp
                      --enable-jpeg
                      --with-pic
                      --prefix=${OUTPUT_DIR}
  INSTALL_COMMAND ""
  BUILD_IN_SOURCE 1)

install(CODE "execute_process(COMMAND make install WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})")

=== depends/windows/lcms2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(lcms2)

set(SOURCES src/cmsalpha.c
            src/cmscam02.c
            src/cmscgats.c
            src/cmscnvrt.c
            src/cmserr.c
            src/cmsgamma.c
            src/cmsgmt.c
            src/cmshalf.c
            src/cmsintrp.c
            src/cmsio0.c
            src/cmsio1.c
            src/cmslut.c
            src/cmsmd5.c
            src/cmsmtrx.c
            src/cmsnamed.c
            src/cmsopt.c
            src/cmspack.c
            src/cmspcs.c
            src/cmsplugin.c
            src/cmsps2.c
            src/cmssamp.c
            src/cmssm.c
            src/cmstypes.c
            src/cmsvirt.c
            src/cmswtpnt.c
            src/cmsxform.c
            src/lcms2_internal.h)

set(HEADERS include/lcms2.h
            include/lcms2_plugin.h)

add_library(${PROJECT_NAME} ${SOURCES} ${HEADERS})
target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include)

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
)

if(MSVC AND BUILD_SHARED_LIBS)
  install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION lib)
endif()

install(FILES ${HEADERS} DESTINATION include)

=== depends/windows/libraw/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(libraw VERSION 0.19.0 LANGUAGES CXX)

add_library(${PROJECT_NAME}
  src/libraw_c_api.cpp
  src/libraw_cxx.cpp
  src/libraw_datastream.cpp
  libraw/libraw_alloc.h
  libraw/libraw_const.h
  libraw/libraw_datastream.h
  libraw/libraw_internal.h
  libraw/libraw_types.h
  libraw/libraw_version.h
  libraw/libraw.h
  internal/dcraw_common.cpp
  internal/dcraw_fileio.cpp
  internal/demosaic_packs.cpp
)

target_include_directories(${PROJECT_NAME}
  PRIVATE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/libraw>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  INTERFACE
  $<INSTALL_INTERFACE:include/libraw>
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/libraw>
)

target_compile_definitions(${PROJECT_NAME}
  PRIVATE
  _CRT_NONSTDC_NO_DEPRECATE
  _CRT_SECURE_NO_WARNINGS
  _CRT_STDC_NO_DEPRECATE
  _USRDLL
  QT_NO_DEBUG
  _WINDOWS
  UNICODE
  QT_LARGEFILE_SUPPORT
  LIBRAW_BUILDLIB
  LIBRAW_NODLL
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion
)

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
)

install(DIRECTORY
  ${CMAKE_CURRENT_SOURCE_DIR}/libraw
  DESTINATION include
)

install(EXPORT ${PROJECT_NAME}
  FILE
  ${PROJECT_NAME}.cmake
  NAMESPACE
    ${PROJECT_NAME}::
  DESTINATION
    lib/cmake/${PROJECT_NAME}
)

install(FILES
  cmake/${PROJECT_NAME}-config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
  DESTINATION
    lib/cmake/${PROJECT_NAME}
)

export(TARGETS ${PROJECT_NAME}
  FILE
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake
  NAMESPACE ${PROJECT_NAME}::
)

if(MSVC AND BUILD_SHARED_LIBS)
  install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION lib)
endif()

=== PKGBUILD ===
# Maintainer: BlackIkeEagle <ike DOT devolder AT gmail DOT com>

pkgname=kodi-addon-imagedecoder-raw
pkgver=20.1.0
_codename=Nexus  # No Omega tagged version yet
pkgrel=16
pkgdesc="Kodi raw imagedecoder addon"
arch=('x86_64')
url="https://github.com/xbmc/imagedecoder.raw"
license=('GPL2')
groups=('kodi-addons' 'kodi-addons-imagedecoder')
makedepends=('cmake' 'kodi-dev' 'libraw')
options=(!lto)
source=("$pkgname-$pkgver.tar.gz::https://github.com/xbmc/imagedecoder.raw/archive/refs/tags/$pkgver-$_codename.tar.gz")
sha512sums=('88701d1937a9ef6dd32b733a1ea33a462fafd8d0c37ff9ca2d8c892114db120135dc17f6fcc7dfe58dd5410cb6feee48654564b8fdf2a6b1cb241a80e4345bc5')

build() {
    cd "imagedecoder.raw-$pkgver-$_codename"
    cmake \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DCMAKE_BUILD_TYPE=Release \
        -DBUILD_SHARED_LIBS=1 \
        -DUSE_LTO=1 \
        .
    make
}

package() {
    depends=('kodi' 'libraw')
    cd "imagedecoder.raw-$pkgver-$_codename"
    make DESTDIR="$pkgdir/" install
}
